diff -crN nakedmudv2.0/src/olc2/olc.h nakedmudv2.1/src/olc2/olc.h
*** nakedmudv2.0/src/olc2/olc.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/olc2/olc.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 40,46 ****
  //                 will be passed to the modifier() function to perform changes
  //                 after an argument is passed in.
  //       the chooser function is of the form:
! //       int chooser(SOCKET_DATA *sock, datatype *to_edit, char option)
  //
  // parser: This function is used to parse an argument, given a choice from the
  //       menu. The choice is provided by the chooser() function, and an argument
--- 40,46 ----
  //                 will be passed to the modifier() function to perform changes
  //                 after an argument is passed in.
  //       the chooser function is of the form:
! //       int chooser(SOCKET_DATA *sock, datatype *to_edit, const char *option)
  //
  // parser: This function is used to parse an argument, given a choice from the
  //       menu. The choice is provided by the chooser() function, and an argument
***************
*** 108,111 ****
--- 108,115 ----
  void olc_display_table(SOCKET_DATA *sock, const char *getName(int val),
  		       int num_vals, int num_cols);
  
+ //
+ // Same deal as olc_display_table, except that it takes in a list of strings
+ void olc_display_list(SOCKET_DATA *sock, LIST *list, int num_cols);
+ 
  #endif // OLC2_H
diff -crN nakedmudv2.0/src/olc2/olc_submenus.h nakedmudv2.1/src/olc2/olc_submenus.h
*** nakedmudv2.0/src/olc2/olc_submenus.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/olc2/olc_submenus.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 16,21 ****
  void edesc_set_menu   (SOCKET_DATA *sock, EDESC_SET *set);
  bool edesc_set_parser (SOCKET_DATA *sock, EDESC_SET *set, int choice,
  		       const char *arg);
! int  edesc_set_chooser(SOCKET_DATA *sock, char option, EDESC_SET *set);
  
  #endif // OLC_SUBMENUS_H
--- 16,26 ----
  void edesc_set_menu   (SOCKET_DATA *sock, EDESC_SET *set);
  bool edesc_set_parser (SOCKET_DATA *sock, EDESC_SET *set, int choice,
  		       const char *arg);
! int  edesc_set_chooser(SOCKET_DATA *sock, EDESC_SET *set, const char *option);
! 
! // for bitvectors
! void bedit_menu   (SOCKET_DATA *sock, BITVECTOR *v);
! bool bedit_parser (SOCKET_DATA *sock, BITVECTOR *v, int choice,const char *arg);
! int  bedit_chooser(SOCKET_DATA *sock, BITVECTOR *v, const char *option);
  
  #endif // OLC_SUBMENUS_H
diff -crN nakedmudv2.0/src/olc2/redit.c nakedmudv2.1/src/olc2/redit.c
*** nakedmudv2.0/src/olc2/redit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/olc2/redit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 46,52 ****
  
  // the resedit olc needs these declared
  void rrledit_menu(SOCKET_DATA *sock, LIST *list);
! int  rrledit_chooser(SOCKET_DATA *sock, LIST *list, char option);
  bool rrledit_parser(SOCKET_DATA *sock, LIST *list, int choice, const char *arg);
  
  const char *write_reset_arg(int type, const char *arg) {
--- 46,52 ----
  
  // the resedit olc needs these declared
  void rrledit_menu(SOCKET_DATA *sock, LIST *list);
! int  rrledit_chooser(SOCKET_DATA *sock, LIST *list, const char *option);
  bool rrledit_parser(SOCKET_DATA *sock, LIST *list, int choice, const char *arg);
  
  const char *write_reset_arg(int type, const char *arg) {
***************
*** 193,202 ****
  		 );
  }
  
! int resedit_chooser(SOCKET_DATA *sock, RESET_DATA *data, char option) {
!   switch(toupper(option)) {
    case '1':
      olc_display_table(sock, resetTypeGetName, NUM_RESETS, 1);
      return RESEDIT_TYPE;
    case '2':
      text_to_buffer(sock, "How many times should the reset execute: ");
--- 193,203 ----
  		 );
  }
  
! int resedit_chooser(SOCKET_DATA *sock, RESET_DATA *data, const char *option) {
!   switch(toupper(*option)) {
    case '1':
      olc_display_table(sock, resetTypeGetName, NUM_RESETS, 1);
+     text_to_buffer(sock, "Pick a reset type: ");
      return RESEDIT_TYPE;
    case '2':
      text_to_buffer(sock, "How many times should the reset execute: ");
***************
*** 316,323 ****
  }
  
  
! int rrledit_chooser(SOCKET_DATA *sock, LIST *list, char option) {
!   switch(toupper(option)) {
    case 'N': {
      RESET_DATA *data = newReset();
      listQueue(list, data);
--- 317,324 ----
  }
  
  
! int rrledit_chooser(SOCKET_DATA *sock, LIST *list, const char *option) {
!   switch(toupper(*option)) {
    case 'N': {
      RESET_DATA *data = newReset();
      listQueue(list, data);
***************
*** 403,410 ****
  		 );
  }
  
! int exedit_chooser(SOCKET_DATA *sock, EXIT_DATA *exit, char option) {
!   switch(option) {
    case '1':
      text_to_buffer(sock, "Enter a new name: ");
      return EXEDIT_NAME;
--- 404,411 ----
  		 );
  }
  
! int exedit_chooser(SOCKET_DATA *sock, EXIT_DATA *exit, const char *option) {
!   switch(toupper(*option)) {
    case '1':
      text_to_buffer(sock, "Enter a new name: ");
      return EXEDIT_NAME;
***************
*** 545,552 ****
  }
  
  
! int redit_chooser(SOCKET_DATA *sock, ROOM_DATA *room, char option) {
!   switch(toupper(option)) {
    case '1':
      text_to_buffer(sock, "Enter a new room name: ");
      return REDIT_NAME;
--- 546,553 ----
  }
  
  
! int redit_chooser(SOCKET_DATA *sock, ROOM_DATA *room, const char *option) {
!   switch(toupper(*option)) {
    case '1':
      text_to_buffer(sock, "Enter a new room name: ");
      return REDIT_NAME;
***************
*** 562,567 ****
--- 563,569 ----
  #endif
    case 'T':
      olc_display_table(sock, terrainGetName, NUM_TERRAINS, 3);
+     text_to_buffer(sock, "Pick a terrain type: ");
      return REDIT_TERRAIN;
    case 'F':
      text_to_buffer(sock, "What is the name of the exit you wish to fill: ");
diff -crN nakedmudv2.0/src/olc2/zedit.c nakedmudv2.1/src/olc2/zedit.c
*** nakedmudv2.0/src/olc2/zedit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/olc2/zedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 42,49 ****
  }
  
  
! int zedit_chooser(SOCKET_DATA *sock, ZONE_DATA *zone, char option) {
!   switch(toupper(option)) {
    case '1':
      text_to_buffer(sock, "Enter a new zone name: ");
      return ZEDIT_NAME;
--- 42,49 ----
  }
  
  
! int zedit_chooser(SOCKET_DATA *sock, ZONE_DATA *zone, const char *option) {
!   switch(toupper(*option)) {
    case '1':
      text_to_buffer(sock, "Enter a new zone name: ");
      return ZEDIT_NAME;
diff -crN nakedmudv2.0/src/property_table.c nakedmudv2.1/src/property_table.c
*** nakedmudv2.0/src/property_table.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/property_table.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 34,54 ****
  
  
  //*****************************************************************************
- //
  // local functions
- //
  //*****************************************************************************
  
- 
  //
  // Find the bucket the key belongs to
- //
  int find_bucket(int key, int num_buckets) {
    // simple for now: just take the modulo
    return key % num_buckets;
  };
  
  
  //*****************************************************************************
  //
  // implementation of property_table.h
--- 34,51 ----
  
  
  //*****************************************************************************
  // local functions
  //*****************************************************************************
  
  //
  // Find the bucket the key belongs to
  int find_bucket(int key, int num_buckets) {
    // simple for now: just take the modulo
    return key % num_buckets;
  };
  
  
+ 
  //*****************************************************************************
  //
  // implementation of property_table.h
diff -crN nakedmudv2.0/src/races.c nakedmudv2.1/src/races.c
*** nakedmudv2.0/src/races.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/races.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 54,60 ****
  //*****************************************************************************
  void init_races() {
    // create the table for holding race data
!   race_table = newHashtable(RACE_TABLE_SIZE);
  
    // make the default human body
    BODY_DATA *body = newBody();
--- 54,60 ----
  //*****************************************************************************
  void init_races() {
    // create the table for holding race data
!   race_table = newHashtable();
  
    // make the default human body
    BODY_DATA *body = newBody();
diff -crN nakedmudv2.0/src/room.c nakedmudv2.1/src/room.c
*** nakedmudv2.0/src/room.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/room.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 77,83 ****
    for(i = 0; i < NUM_DIRS; i++)
      room->exits[i] = NULL;
  
!   room->special_exits  = newHashtable(SPECIAL_EXIT_BUCKETS);
    room->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_ROOM);
  
    room->edescs     = newEdescSet();
--- 77,83 ----
    for(i = 0; i < NUM_DIRS; i++)
      room->exits[i] = NULL;
  
!   room->special_exits  = newHashtableSize(SPECIAL_EXIT_BUCKETS);
    room->auxiliary_data = newAuxiliaryData(AUXILIARY_TYPE_ROOM);
  
    room->edescs     = newEdescSet();
***************
*** 229,235 ****
      roomSetExitSpecial(to, spec_exits[i], NULL);
    free(spec_exits);
    deleteHashtable(to->special_exits);
!   to->special_exits = newHashtable(SPECIAL_EXIT_BUCKETS);
  
  
    // set the special exits of the <to> room
--- 229,235 ----
      roomSetExitSpecial(to, spec_exits[i], NULL);
    free(spec_exits);
    deleteHashtable(to->special_exits);
!   to->special_exits = newHashtableSize(SPECIAL_EXIT_BUCKETS);
  
  
    // set the special exits of the <to> room
diff -crN nakedmudv2.0/src/scripts/pychar.c nakedmudv2.1/src/scripts/pychar.c
*** nakedmudv2.0/src/scripts/pychar.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/pychar.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 20,25 ****
--- 20,26 ----
  #include "../utils.h"
  
  #include "script.h"
+ #include "script_set.h"
  #include "pychar.h"
  #include "pyroom.h"
  #include "pyobj.h"
***************
*** 38,47 ****
  } PyChar;
  
  
  //*****************************************************************************
- //
  // allocation, deallocation, and initialiation
- //
  //*****************************************************************************
  static void
  PyChar_dealloc(PyChar *self) {
--- 39,47 ----
  } PyChar;
  
  
+ 
  //*****************************************************************************
  // allocation, deallocation, and initialiation
  //*****************************************************************************
  static void
  PyChar_dealloc(PyChar *self) {
***************
*** 82,92 ****
  
  
  
- 
  //*****************************************************************************
- //
  // methods and stuff for building the class
- //
  //*****************************************************************************
  
  //
--- 82,89 ----
***************
*** 203,209 ****
  
  //
  // Set the value of a variable assocciated with the character
- //
  static PyObject *
  PyChar_setvar(PyChar *self, PyObject *args) {  
    char     *var = NULL;
--- 200,205 ----
***************
*** 215,221 ****
      return NULL;
    }
  
- 
    CHAR_DATA *ch = propertyTableGet(mob_table, self->uid);
    if(ch != NULL) {
      if(PyInt_Check(val))
--- 211,216 ----
***************
*** 241,266 ****
  }
  
  
  
  static PyMethodDef PyChar_methods[] = {
!     {"send", (PyCFunction)PyChar_send, METH_VARARGS,
!      "send a message to the character." },
!     {"sendaround", (PyCFunction)PyChar_sendaround, METH_VARARGS,
!      "send a message to everyone around a character."},
!     {"act", (PyCFunction)PyChar_act, METH_VARARGS,
!      "make the character perform an action." },
!     {"getvar", (PyCFunction)PyChar_getvar, METH_VARARGS,
!      "get the value of a special variable the character has."},
!     {"setvar", (PyCFunction)PyChar_setvar, METH_VARARGS,
!      "set the value of a special variable."},
!     {NULL}  /* Sentinel */
  };
  
  
  //*****************************************************************************
- //
  // character attributes - mostly get and set
- //
  //*****************************************************************************
  static PyObject *
  PyChar_getname(PyChar *self, void *closure) {
--- 236,318 ----
  }
  
  
+ static PyObject *
+ PyChar_attach(PyChar *self, PyObject *args) {  
+   long vnum = NOTHING;
+ 
+   // make sure we're getting passed the right type of data
+   if (!PyArg_ParseTuple(args, "i", &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "To attach a script, the vnum must be suppplied.");
+     return NULL;
+   }
+ 
+   // pull out the character and do the attaching
+   CHAR_DATA       *ch = propertyTableGet(mob_table, self->uid);
+   SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+   if(ch != NULL && script != NULL) {
+     scriptSetAdd(charGetScripts(ch), vnum);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to attach script to nonexistant char, %d, or script %d "
+ 		 "does not exit.", self->uid, (int)vnum);
+     return NULL;
+   }
+ }
+ 
+ 
+ static PyObject *
+ PyChar_detach(PyChar *self, PyObject *args) {  
+   long vnum = NOTHING;
+ 
+   // make sure we're getting passed the right type of data
+   if (!PyArg_ParseTuple(args, "i", &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "To detach a script, the vnum must be suppplied.");
+     return NULL;
+   }
+ 
+   // pull out the character and do the attaching
+   CHAR_DATA       *ch = propertyTableGet(mob_table, self->uid);
+   SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+   if(ch != NULL && script != NULL) {
+     scriptSetRemove(charGetScripts(ch), vnum);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to detach script from nonexistant char, %d, or script "
+ 		 "%d does not exit.", self->uid, (int)vnum);
+     return NULL;
+   }
+ }
+ 
+ 
  
  static PyMethodDef PyChar_methods[] = {
!   {"attach", (PyCFunction)PyChar_attach, METH_VARARGS,
!    "attach a new script to the character." },
!   {"detach", (PyCFunction)PyChar_detach, METH_VARARGS,
!    "detach a script from the character." },
!   {"send", (PyCFunction)PyChar_send, METH_VARARGS,
!    "send a message to the character." },
!   {"sendaround", (PyCFunction)PyChar_sendaround, METH_VARARGS,
!    "send a message to everyone around a character."},
!   {"act", (PyCFunction)PyChar_act, METH_VARARGS,
!    "make the character perform an action." },
!   {"getvar", (PyCFunction)PyChar_getvar, METH_VARARGS,
!    "get the value of a special variable the character has."},
!   {"setvar", (PyCFunction)PyChar_setvar, METH_VARARGS,
!    "set the value of a special variable."},
!   {NULL}  /* Sentinel */
  };
  
  
+ 
  //*****************************************************************************
  // character attributes - mostly get and set
  //*****************************************************************************
  static PyObject *
  PyChar_getname(PyChar *self, void *closure) {
***************
*** 692,705 ****
  
  
  //*****************************************************************************
- //
  // comparators, getattr, setattr, and all that other class stuff
- //
  //*****************************************************************************
  
  //
  // compare one character to another
- //
  static int
  PyChar_compare(PyChar *ch1, PyChar *ch2) {
    if(ch1->uid == ch2->uid)
--- 744,754 ----
***************
*** 755,763 ****
  
  
  //*****************************************************************************
- //
  // the char module
- //
  //*****************************************************************************
  static PyObject *
  PyChar_load_mob(PyObject *self, PyObject *args) {
--- 804,810 ----
***************
*** 901,907 ****
--- 948,969 ----
  }
  
  
+ static PyObject *
+ PyChar_all_chars(PyObject *self) {
+   PyObject      *list = PyList_New(0);
+   LIST_ITERATOR *ch_i = newListIterator(mobile_list);
+   CHAR_DATA       *ch = NULL;
+   ITERATE_LIST(ch, ch_i)
+     PyList_Append(list, newPyChar(ch));
+   deleteListIterator(ch_i);
+   return Py_BuildValue("O", list);
+ }
+ 
+ 
+ 
  static PyMethodDef char_module_methods[] = {
+   { "all_chars", (PyCFunction)PyChar_all_chars, METH_NOARGS,
+     "Return a python list containing an entry for every character in game." },
    { "load_mob", PyChar_load_mob, METH_VARARGS,
      "load a mobile with the specified vnum to a room." },
    { "count_mobs", PyChar_count_mobs, METH_VARARGS,
diff -crN nakedmudv2.0/src/scripts/pyobj.c nakedmudv2.1/src/scripts/pyobj.c
*** nakedmudv2.0/src/scripts/pyobj.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/pyobj.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 20,25 ****
--- 20,26 ----
  #include "../utils.h"
  
  #include "script.h"
+ #include "script_set.h"
  #include "pychar.h"
  #include "pyroom.h"
  #include "pyobj.h"
***************
*** 81,88 ****
  // methods and stuff for building the class
  //
  //*****************************************************************************
  static PyMethodDef PyObj_methods[] = {
!     {NULL}  /* Sentinel */
  };
  
  
--- 82,148 ----
  // methods and stuff for building the class
  //
  //*****************************************************************************
+ 
+ static PyObject *
+ PyObj_attach(PyObj *self, PyObject *args) {  
+   long vnum = NOTHING;
+ 
+   // make sure we're getting passed the right type of data
+   if (!PyArg_ParseTuple(args, "i", &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "To attach a script, the vnum must be suppplied.");
+     return NULL;
+   }
+ 
+   // pull out the character and do the attaching
+   OBJ_DATA       *obj = propertyTableGet(obj_table, self->uid);
+   SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+   if(obj != NULL && script != NULL) {
+     scriptSetAdd(objGetScripts(obj), vnum);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to attach script to nonexistant obj, %d, or script %d "
+ 		 "does not exit.", self->uid, (int)vnum);
+     return NULL;
+   }
+ }
+ 
+ 
+ static PyObject *
+ PyObj_detach(PyObj *self, PyObject *args) {  
+   long vnum = NOTHING;
+ 
+   // make sure we're getting passed the right type of data
+   if (!PyArg_ParseTuple(args, "i", &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "To detach a script, the vnum must be suppplied.");
+     return NULL;
+   }
+ 
+   // pull out the character and do the attaching
+   OBJ_DATA       *obj = propertyTableGet(obj_table, self->uid);
+   SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+   if(obj != NULL && script != NULL) {
+     scriptSetRemove(objGetScripts(obj), vnum);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to detach script from nonexistant obj, %d, or script "
+ 		 "%d does not exit.", self->uid, (int)vnum);
+     return NULL;
+   }
+ }
+ 
+ 
  static PyMethodDef PyObj_methods[] = {
!   {"attach", (PyCFunction)PyObj_attach, METH_VARARGS,
!    "attach a new script to the object." },
!   {"detach", (PyCFunction)PyObj_detach, METH_VARARGS,
!    "detach a script from the object." },
!   {NULL}  /* Sentinel */
  };
  
  
diff -crN nakedmudv2.0/src/scripts/pyroom.c nakedmudv2.1/src/scripts/pyroom.c
*** nakedmudv2.0/src/scripts/pyroom.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/pyroom.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 20,25 ****
--- 20,26 ----
  #include "../utils.h"
  
  #include "script.h"
+ #include "script_set.h"
  #include "pyroom.h"
  #include "pychar.h"
  #include "pyobj.h"
***************
*** 30,39 ****
  } PyRoom;
  
  
  //*****************************************************************************
- //
  // allocation, deallocation, and initialiation
- //
  //*****************************************************************************
  static void
  PyRoom_dealloc(PyRoom *self) {
--- 31,39 ----
  } PyRoom;
  
  
+ 
  //*****************************************************************************
  // allocation, deallocation, and initialiation
  //*****************************************************************************
  static void
  PyRoom_dealloc(PyRoom *self) {
***************
*** 75,88 ****
  
  
  //*****************************************************************************
- //
  // methods and stuff for building the class
- //
  //*****************************************************************************
  
  //
  // Send a newline-tagged message to everyone in the room
- //
  static PyObject *
  PyRoom_send(PyRoom *self, PyObject *value) {
    char *mssg = NULL;
--- 75,85 ----
***************
*** 108,114 ****
  
  //
  // close a door in the specified direction
- //
  static PyObject *
  PyRoom_close(PyRoom *self, PyObject *value) {
    ROOM_DATA *room = NULL;
--- 105,110 ----
***************
*** 161,167 ****
  
  //
  // lock a door in the specified direction
- //
  static PyObject *
  PyRoom_lock(PyRoom *self, PyObject *value) {
    ROOM_DATA *room = NULL;
--- 157,162 ----
***************
*** 221,227 ****
  
  //
  // lock a door in the specified direction
- //
  static PyObject *
  PyRoom_unlock(PyRoom *self, PyObject *value) {
    ROOM_DATA *room = NULL;
--- 216,221 ----
***************
*** 280,286 ****
  
  //
  // close a door in the specified direction
- //
  static PyObject *
  PyRoom_open(PyRoom *self, PyObject *value) {
    ROOM_DATA *room = NULL;
--- 274,279 ----
***************
*** 325,350 ****
  }
  
  
  
  static PyMethodDef PyRoom_methods[] = {
!     {"close", (PyCFunction)PyRoom_close, METH_VARARGS,
!      "close a door in the specified direction." },
!     {"open", (PyCFunction)PyRoom_open, METH_VARARGS,
!      "open a door in the specified direction. Unlocks it if neccessary." },
!     {"lock", (PyCFunction)PyRoom_lock, METH_VARARGS,
!      "lock a door in the specified direction, closing it if it is open." },
!     {"unlock", (PyCFunction)PyRoom_unlock, METH_VARARGS,
!      "unlocks the door in the specified direction." },
!     {"send", (PyCFunction)PyRoom_send, METH_VARARGS,
!      "send a message to everyone in the room."},
!     {NULL}  /* Sentinel */
  };
  
  
  //*****************************************************************************
- //
  // character attributes - mostly get and set
- //
  //*****************************************************************************
  static PyObject *
  PyRoom_getvnum(PyRoom *self, void *closure) {
--- 318,398 ----
  }
  
  
+ static PyObject *
+ PyRoom_attach(PyRoom *self, PyObject *args) {  
+   long vnum = NOTHING;
+ 
+   // make sure we're getting passed the right type of data
+   if (!PyArg_ParseTuple(args, "i", &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "To attach a script, the vnum must be supplied.");
+     return NULL;
+   }
+ 
+   // pull out the character and do the attaching
+   ROOM_DATA     *room = worldGetRoom(gameworld, self->vnum);
+   SCRIPT_DATA *script = worldGetScript(gameworld, vnum);
+   if(room != NULL && script != NULL) {
+     scriptSetAdd(roomGetScripts(room), vnum);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to attach script to nonexistant room, %d, or script %d "
+ 		 "does not exit.", self->vnum, (int)vnum);
+     return NULL;
+   }
+ }
+ 
+ 
+ static PyObject *
+ PyRoom_detach(PyRoom *self, PyObject *args) {  
+   long vnum = NOTHING;
+ 
+   // make sure we're getting passed the right type of data
+   if (!PyArg_ParseTuple(args, "i", &vnum)) {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "To detach a script, the vnum must be suppplied.");
+     return NULL;
+   }
+ 
+   // pull out the character and do the attaching
+   ROOM_DATA     *room = worldGetRoom(gameworld, self->vnum);
+   SCRIPT_DATA *script = worldGetScript(gameworld, (int)vnum);
+   if(room != NULL && script != NULL) {
+     scriptSetRemove(roomGetScripts(room), vnum);
+     return Py_BuildValue("i", 1);
+   }
+   else {
+     PyErr_Format(PyExc_TypeError, 
+ 		 "Tried to detach script from nonexistant room, %d, or script "
+ 		 "%d does not exit.", self->vnum, (int)vnum);
+     return NULL;
+   }
+ }
+ 
  
  static PyMethodDef PyRoom_methods[] = {
!   {"attach", (PyCFunction)PyRoom_attach, METH_VARARGS,
!    "attach a new script to the room." },
!   {"detach", (PyCFunction)PyRoom_detach, METH_VARARGS,
!    "detach a script from the room." },
!   {"close", (PyCFunction)PyRoom_close, METH_VARARGS,
!    "close a door in the specified direction." },
!   {"open", (PyCFunction)PyRoom_open, METH_VARARGS,
!    "open a door in the specified direction. Unlocks it if neccessary." },
!   {"lock", (PyCFunction)PyRoom_lock, METH_VARARGS,
!    "lock a door in the specified direction, closing it if it is open." },
!   {"unlock", (PyCFunction)PyRoom_unlock, METH_VARARGS,
!    "unlocks the door in the specified direction." },
!   {"send", (PyCFunction)PyRoom_send, METH_VARARGS,
!    "send a message to everyone in the room."},
!   {NULL}  /* Sentinel */
  };
  
  
  //*****************************************************************************
  // character attributes - mostly get and set
  //*****************************************************************************
  static PyObject *
  PyRoom_getvnum(PyRoom *self, void *closure) {
***************
*** 405,413 ****
  
  
  //*****************************************************************************
- //
  // comparators, getattr, setattr, and all that other class stuff
- //
  //*****************************************************************************
  
  //
--- 453,459 ----
***************
*** 468,476 ****
  
  
  //*****************************************************************************
- //
  // the room module
- //
  //*****************************************************************************
  static PyMethodDef room_module_methods[] = {
    {NULL, NULL, 0, NULL}  /* Sentinel */
--- 514,520 ----
